<?php
/*
Plugin Name: Get_OPML
Plugin URI: http://photozero.net/get_opml
Description: The plugin can search for the RSS address from your blog Links(Blogroll) automatically,and create a OPML menu.You can insert it into the Reader that support OPML like Google Reader(http://reader.google.com),then you can add all RSS address to Reader one-time.(Read the readme.txt file get more information!)<br />You can get the RSS url from Technorati.com now!(Version 3.1.0) Faster,and more efficient! It needs a Technorati API-KEY from <a href="http://technorati.com/developers/apikey.html">http://technorati.com/developers/apikey.html</a> by free.
Author: Neekey
Version: 3.1.0
Author URI: http://photozero.net/
*/


//You need a Technorati API KEY first.Please visit  http://technorati.com/developers/apikey.html
$technorati_api = 'dfe71294d89ebbca982c98ecd73c96d5';




//Don't Remove or edit.Thanks!
$get_opml_version = '3.1.0';
$get_opml_file = ABSPATH .'opml.xml';


if ( !defined('WP_CONTENT_DIR') )
	define( 'WP_CONTENT_DIR', ABSPATH . 'wp-content' );
$plugin_path = WP_CONTENT_DIR.'/plugins/';


function display_get_opml() {
	if (function_exists('add_options_page')) {
		add_options_page('Get_OPML Setting', 'Get_OPML', 'manage_options', 'get-opml/page.php') ;
	}
}

function get_technorati_rss($site){
	//http://api.technorati.com/bloginfo?key=[apikey]&url=[blog url]
	//apikey: dfe71294d89ebbca982c98ecd73c96d5
	global $technorati_api;
	if(!$technorati_api)	$technorati_api = 'dfe71294d89ebbca982c98ecd73c96d5';
	
	$fp = @fsockopen('api.technorati.com', 80, $errnum, $errstr, 15);
	if($fp) { 
		$fp_data ="GET /bloginfo?key={$technorati_api}&url={$site} HTTP/1.0\r\n";
		$fp_data.="Host: api.technorati.com \r\n"; 
		$fp_data.="User-Agent: Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 6.0) \r\n";
		$fp_data.="Connection: Close\r\n\r\n";
		fputs($fp, $fp_data);
		while(!feof($fp)) {
			$data.=fgets($fp, 512);
		}
		fclose($fp);
	} else {
		return false;
	}
	$data=substr($data, strpos($data, "\r\n\r\n"), strlen($data));
	$pattern = '/<atomurl>\s*(.+?)<\/atomurl>/';
	preg_match($pattern, $data, $match);
	$pattern2 = '/<rssurl>\s*(.+?)<\/rssurl>/';
	preg_match($pattern2, $data, $match2);
	$arr = array('atom' => $match[1],'rss' => $match2[1]);
	return $arr;
}


function print_process($total,$finished,$title,$url,$rss,$get_type = 'Technorati'){
	header('Content-Type: text/xml');
	echo '<?xml version="1.0" encoding="UTF-8"?>'."\r\n";
	echo '<getopml>'."\r\n";
	

	echo '<count>'.$total.'</count>'."\r\n";
	echo '<finished>'. $finished .'</finished>'."\r\n";
	echo '<gettype>'. $get_type .'</gettype>'."\r\n";
	
	echo '<title>'.$title.'</title>'."\r\n";
	echo '<url>'. $url .'</url>'."\r\n";
	echo '<rss>'. $rss .'</rss>'."\r\n";
	
	
	echo '</getopml>';
}

function print_opml($returnxml = 0){

	global $wpdb,$get_opml_file,$get_opml_version;
	$q = "SELECT link_id,link_url,link_name,link_rss FROM $wpdb->links ORDER BY link_id ASC";
	$all_lists = $wpdb->get_results($q);
	$counts = count($all_lists);
	
	$filetext = '<?xml version="1.0" encoding="utf-8"?><!-- generator="Get_OPML version ' .$get_opml_version. ' By http://photozero.net/get_opml" -->'."\r\n";
	$filetext .= '<opml version="1.0">'."\r\n";
	$filetext .= "<head>\r\n<title>".get_bloginfo('name')." Share</title>\r\n</head>\r\n";
	$filetext .= "<body>\r\n";
	$filetext .= "<outline title=\"".get_bloginfo('name')." Share\" text=\"".get_bloginfo('name')." Share\">\r\n\r\n".'<outline text="'.get_bloginfo('name').'" title="'.get_bloginfo('name').'" type="rss" xmlUrl="'.get_bloginfo('rss_url').'" htmlUrl="'.get_bloginfo('url').'"/>'."\r\n";
	foreach ($all_lists as $key){
		if($key->link_rss == 'empty' || $key->link_rss == ''){
			$filetext .= '<outline title="'.$key->link_name.'" text="'.$key->link_description.'" type="rss" xmlUrl="" htmlUrl="'.$key->link_url.'"/>'."\r\n";
		}else{
			$filetext .= '<outline title="'.$key->link_name.'" text="'.$key->link_description.'" type="rss" xmlUrl="'.$key->link_rss.'" htmlUrl="'.$key->link_url.'"/>'."\r\n";
		}
	}
	
	$filetext .= '<outline title="Photozero.net" text="Photozero.net" type="rss" xmlUrl="http://feed.photozero.net" htmlUrl="http://photozero.net"/>';
	$filetext .= "\r\n\r\n</outline>\r\n</body>\r\n</opml>";
	$fh = fopen( $get_opml_file ,'w+');
	fwrite($fh,$filetext);
	fclose($fh);
	
	if($returnxml){
		header('Content-Type: text/xml');
		echo '<?xml version="1.0" encoding="UTF-8"?>'."\r\n";
		echo '<getopml>'."\r\n";
		echo '<createopml>1</createopml>'."\r\n";
		echo '</getopml>';
		exit;
	}
}


function check_get_opml(){
	if($_GET['getopmlstatus'] == 'runing'){

		global $plugin_path;
		
		
		function analyse_rss_url($texts){
			$match = '/<link.+?rel=[\"|\']?alternate[\"|\']?.+?href=[\"|\']?([^(\"|\')]*)[\"|\']?/is';
			preg_match_all($match, $texts, $match);
			//print_r($match);
			$result = $match[1][0];
			return $result;
		}
	
		global $wpdb;
		
		$step = intval($_GET['getopmlstep']);
		$q = "SELECT link_id,link_url,link_name,link_rss FROM $wpdb->links ORDER BY link_id ASC";
		$all_lists = $wpdb->get_results($q);
		$counts = count($all_lists);
		$gid = $all_lists[$step]->link_id;
		
		$urlresult = get_technorati_rss($all_lists[$step]->link_url);$get_url_type = 'Technorati';
		$url = $urlresult['atom'];
		if(!$url)	$url = $urlresult['rss'];
		
		if(!$url){
			include($plugin_path.'get-opml/download.class.php');
			$_get_opml = new DedeHttpDown();
			$_get_opml->OpenUrl($all_lists[$step]->link_url);
			$_get_opml->GetHtml();
			$url = analyse_rss_url($_get_opml->GetHtml());
			$_get_opml->Close();
			$get_url_type = 'The Website';
		}
		
		if ($url == ''){//No RSS address
			$q = "UPDATE $wpdb->links SET link_rss='empty' WHERE link_id = $gid";
			$wpdb->get_results($q);
		}else{
			$q = "UPDATE $wpdb->links SET link_rss='$url' WHERE link_id = $gid";
			$wpdb->get_results($q);
		}
		
		$newstep = $step+1;
		
		if ($step == $counts-1){
			//Finished all works.
			//print_opml();//Create OPML file
			print_process($counts,$counts,$all_lists[$step]->link_name,$all_lists[$step]->link_url,$url,$get_url_type);
			
		}else{
			
			print_process($counts,$newstep,$all_lists[$step]->link_name,$all_lists[$step]->link_url,$url,$get_url_type);
			
		}
		
		
		
		exit;
	}elseif($_GET['getopmlstatus'] == 'getfile'){
		//Create OPML file
		print_opml(1);
	}
}




add_action('init', 'check_get_opml');
add_action('admin_menu', 'display_get_opml');

?>